import { NgModule, ModuleWithProviders } from '@angular/core';
import { MDynamicDialogComponent } from "./m-dynamic-dialog/m-dynamic-dialog.component";
import { MDynamicDialogBodyComponent } from "./m-dynamic-dialog/m-dynamic-dialog-body/m-dynamic-dialog-body.component";
import { MaterialButtonComponent } from './other-components/material-button/material-button.component';
import { CommonModule } from '@angular/common'; 
import { MDynamicDialogReference } from './m-dynamic-dialog-services/m-dynamic-dialog-reference.service'; 
import { MDynamicDialogData } from './m-dynamic-dialog-services/m-dynamic-dialog-data.service'; 
import { MDynamicDialogService } from './m-dynamic-dialog-services/m-dynamic-dialog.service'; 
import { MDynamicDialogParameter } from './models/m-dynamic-dialog-parameter';

@NgModule({
  declarations: [
    MDynamicDialogBodyComponent,
    MDynamicDialogComponent,
    MaterialButtonComponent
  ],
  imports: [
    CommonModule,
  ],
  entryComponents: [
    MDynamicDialogBodyComponent,
    MDynamicDialogComponent
  ],
  exports: [
    MDynamicDialogBodyComponent,
    MaterialButtonComponent
  ]
})
export class MDynamicDialogModule {

  static forRoot(): ModuleWithProviders {
    return {
      ngModule: MDynamicDialogModule,
      providers: [MDynamicDialogService, MDynamicDialogReference, MDynamicDialogData, MDynamicDialogParameter]
    };
  }
}
